Description

Currently CoCoALib does not permit automatic promotion with operators like +=.

This means that one cannot do, for instance, f /= content(f);

even though f = f/content(f); works just fine.  This feel inconsistent!

There is the question about whether to permit the LHS to be promoted automatically.

At the moment I cannot think of a situation where this would be convenient/useful

[but that alone is not sufficient to exclude the possibility].  If we do forbid it,

then again we have a situation where a = a+b;  has (slightly) different behaviour

from a +=b;

Related issues:

Related to CoCoALib - Feature #645: Automatic mapping of RingElem: user selec... Rejected 04 Nov 2014

History

#1 - 15 Jun 2022 22:29 - John Abbott

I have made a first update (not checked in) which allows the RHS to be promoted, but not the LHS.

Somehow it "feels funny" to allow the LHS to be promoted automatically... but that is not really

a good reason to forbid it.

What do you think?

#2 - 08 Mar 2023 20:52 - John Abbott

- Status changed from New to In Progress

- Assignee set to John Abbott

- % Done changed from 0 to 80

The current impl gives an error if the LHS would be promoted.

I am inclined to accept this impl, and close this issue.

If people object, it should be easy to change the code to allow the LHS to be promoted too.

What do you think?

#3 - 09 Mar 2023 22:23 - John Abbott

- Status changed from In Progress to Closed

- % Done changed from 80 to 100

- Estimated time set to 0.88 h

#4 - 16 Feb 2024 17:35 - Anna Maria Bigatti
- Related to Feature #645: Automatic mapping of RingElem: user selectable at run-time (GlobalManager?) added

#5 - 16 Feb 2024 17:35 - Anna Maria Bigatti

- Subject changed from Automatic promotion of RHS in += etc to Automatic mapping of RHS in += etc
